/* initialize connection to server, get its Desktop-service and XComponentLoader interface */
xMsf=ooo.connect()   -- connect to server and retrieve remote multi server factory

-- Retrieve the Desktop object, we need its XComponentLoader interface
-- to load a new document
oDesktop         = xMsf~createInstance("com.sun.star.frame.Desktop")
xDesktop         = oDesktop~XDesktop          -- get desktop interface
xComponentLoader = xDesktop~XComponentLoader  -- get componentLoader interface

/* load an empty text document */
oSheetComponent = xComponentLoader~loadComponentFromURL("private:factory/scalc", "_blank", 0, .OOo~noProps)

xSheet=oSheetComponent~XSpreadSheetDocument~getSheets~XIndexAccess~getByIndex(0)~XSpreadSheet

-- first, insert some numeric data
do i=0 to 9
	do j=0 to 9
		call OOo.setCell xSheet, i, j, i*j
	end
end

-- Insert "formulas"
-- First, insert a real formula:
call OOo.setCell xSheet, 1, 10, "=SUM(B1:B10)"

-- Second, insert a text string
call OOo.setCell xSheet, 2, 10, "-> This is the sum!"


::requires OOO.CLS   -- ooRexx support for OpenOffice.org
